<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <s:div id="globalDiv">
                <h1>#{messages['gazelle.hl7.HL7v2RespondersSystemsUnderTest']})</h1>
                <s:decorate template="/sut/configurationsTable_common.xhtml">
                    <ui:param name="confman" value="#{hl7v2ResponderSUTConfManager}"></ui:param>
                    <ui:param name="restrictAccess" value="#{true}"></ui:param>
                    <ui:define name="additionalText"></ui:define>
                    <ui:define name="filters">
                        <div class="form-horizontal">
                            <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:define name="label">#{messages['gazelle.hl7.Usage']}</ui:define>
                                <ui:param name="id" value="usageFilter"/>
                                <h:selectOneMenu value="#{hl7v2ResponderSUTConfManager.filteredUsage}"
                                                 id="usageFilter" styleClass="form-control gzl-select-text">
                                    <s:selectItems value="#{hl7v2ResponderSUTConfManager.getPossibleListUsages()}"
                                                   var="us" label="#{us.getLabelForFilter()}"
                                                   noSelectionLabel="#{messages['gazelle.hl7.ShowAll']}"/>
                                    <a4j:ajax event="change" render="globalForm"/>
                                </h:selectOneMenu>
                            </ui:decorate>
                            <h:panelGroup rendered="#{identity.loggedIn}">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{hl7v2ResponderSUTConfManager.filter}"/>
                                    <ui:param name="filterId" value="owner"/>
                                    <ui:param name="filterName" value="#{messages['gazelle.simu.Owner']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </h:panelGroup>
                        </div>
                    </ui:define>
                    <ui:param name="globalFormId" value="globalForm"/>
                    <ui:define name="additional_columns">
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.hl7.ReceivingApplication']}/#{messages['gazelle.hl7.ReceivingFacility']}</ui:define>
                            <h:outputText value="#{currentConfig.application}/#{currentConfig.facility}"/>
                        </g:column>
                    </ui:define>
                </s:decorate>
                <s:decorate template="/sut/editSystemConfig_common.xhtml">
                    <ui:param name="confman" value="#{hl7v2ResponderSUTConfManager}"/>
                    <ui:param name="restrictAccess" value="true"/>
                    <ui:param name="displayUsageSelection" value="true"/>
                    <ui:param name="displayUrlInput" value="false"/>
                    <ui:define name="additional_attributes">
                        <s:decorate id="editCharsetDecorate" template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['gazelle.HL7Common.Charset']}</ui:define>
                            <ui:param name="id" value="CharsetSelectionBox"/>
                            <h:selectOneMenu id="CharsetSelectionBox" styleClass="form-control"
                                             value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.charset}"
                                             required="true">
                                <s:selectItems value="#{charset.getAllCharsets()}" var="currentCharset"
                                               noSelectionLabel="#{messages['gazelle.simulator.PleaseSelect']}"
                                               label="#{currentCharset.displayName}"/>
                            </h:selectOneMenu>
                        </s:decorate>
                        <s:decorate id="editreceivingAppDecorate" template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['gazelle.HL7Common.ReceivingApplication']}
                            </ui:define>
                            <ui:param name="id" value="appInput"/>
                            <h:inputText id="appInput" styleClass="form-control"
                                         value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.application}"
                                         maxlength="20"
                                         required="true"/>
                        </s:decorate>
                        <s:decorate id="editreceivingFacDecorate" template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['gazelle.HL7Common.ReceivingFacility']}</ui:define>
                            <ui:param name="id" value="facInput"/>
                            <h:inputText id="facInput" styleClass="form-control"
                                         value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.facility}"
                                         maxlength="20"
                                         required="true"/>
                        </s:decorate>
                        <a4j:region id="protocolRegion">
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.hl7.TransportProtocol']}</ui:define>
                                <ui:param name="id" value="protocolInput"/>
                                <h:selectOneMenu id="protocolInput" styleClass="form-control"
                                                 value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.hl7Protocol}">
                                    <f:selectItems
                                            value="#{hl7v2ResponderSUTConfManager.getHl7Protocols()}"/>
                                    <a4j:ajax event="change" render="protocolDetails"/>
                                </h:selectOneMenu>
                            </s:decorate>
                        </a4j:region>
                        <s:div id="protocolDetails">
                            <s:decorate id="editrepositoryIpDecorate" template="/layout/form/_edit.xhtml"
                                        rendered="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.hl7Protocol == 'MLLP'}">
                                <ui:define name="label">#{messages['gazelle.HL7Common.IPAddress']}</ui:define>
                                <ui:param name="id" value="ipinput"/>
                                <h:inputText id="ipinput"
                                             value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.ipAddress}"
                                             styleClass="form-control" maxlength="15"
                                             required="true"/>
                            </s:decorate>
                            <s:decorate id="editrepositoryPortDecorate" template="/layout/form/_edit.xhtml"
                                        rendered="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.hl7Protocol == 'MLLP'}">
                                <ui:define name="label">#{messages['gazelle.HL7Common.Port']}</ui:define>
                                <ui:param name="id" value="portInput"/>
                                <h:inputText id="portInput"
                                             value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.port}"
                                             styleClass="form-control" maxlength="25"
                                             required="true"/>
                            </s:decorate>
                            <s:decorate template="/layout/form/_edit.xhtml"
                                        rendered="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.hl7Protocol == 'HTTP'}">
                                <ui:define name="label">#{messages['gazelle.hl7.URL']}</ui:define>
                                <ui:param name="id" value="ipv2Input"/>
                                <h:inputText id="ipv2Input" styleClass="form-control"
                                             value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.url}"
                                             required="true"/>
                            </s:decorate>
                        </s:div>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['gazelle.hl7.MessageEncoding']}</ui:define>
                            <ui:param name="id" value="encodingInput"/>
                            <h:selectOneMenu id="encodingInput" styleClass="form-control"
                                             value="#{hl7v2ResponderSUTConfManager.selectedSystemConfiguration.messageEncoding}">
                                <s:selectItems
                                        value="#{hl7v2ResponderSUTConfManager.getEncodings()}"
                                        var="enc" label="#{enc.getValue()}"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </ui:define>
                </s:decorate>
                <ui:include src="/sut/configModalPanel.xhtml">
                    <ui:param name="confman" value="#{hl7v2ResponderSUTConfManager}"></ui:param>
                </ui:include>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
